/* turbo.net browser helper content script */

if(typeof(turboNetBrowserHelperInitialized) === "undefined") {
    turboNetBrowserHelperInitialized = true;

    var redirectMessageHtml = `
        <div id='spoon-banner' style='position: fixed; width: 100%; height: 100%; left: 0px; top: 0px; z-index: 2147483647; padding: 0px; margin: 0px;' onclick='document.getElementById(&quot;spoon-banner&quot;).style.display = &quot;none&quot;;'>
            <table style='width:100%; height: 50px; padding: 0px; margin: 0px; vertical-align: center; border:1px solid; border-color: #b2212e; background: #b2212e no-repeat center scroll;'>
            <tr>
            <td style='padding: 10px; vertical-align: center;'>
            <img src="https://turbo.net/images/turbo-streak-white.png" />
            </td>
            <td style='padding: 10px; vertical-align: center; font-family:Arial; font-size: 16px; font-weight: 600; color: white; padding-left: 10px;'>
            <p style='text-align: center; color: white;'>This domain is configured to open in a different browser. A new browser will open in a separate window.</p>
            </td>
                <td style='vertical-align: top; padding: 10px; font-family:Arial; font-size: 16px;'>
                    <a style='text-decoration: none; color: white;' onclick='document.getElementById(&quot;spoon-banner&quot;).style.display = &quot;none&quot;;' href=''>x</a>
                </td>
            </tr>
            </table>
            <div style='width: 100%; height: 100%; background-color: black; opacity: 0.8;'></div>
        </div>
        `;

    function _insertRedirectMessage() {
        var spoonBanner = document.getElementById('spoon-banner');
        if(spoonBanner !== null) {
            spoonBanner.remove();
        }

        document.body.insertAdjacentHTML('beforeEnd', redirectMessageHtml);
    }

    // handle extension background queries to current tab
    function _onTabMessageHandler(msg, sender, sendResponse) {
        if(typeof msg !== 'object' || !msg.hasOwnProperty('type')) {
            console.error('Failed to process request', msg);
            return;
        }

        function _safeSendResponse(response) {
            if(typeof sendResponse === 'undefined') {
                return;
            }

            sendResponse(response);
        }

        switch(msg.type) {
            case 'insert_redirect_msg':
                _insertRedirectMessage();
                break;
            case 'is_dom_empty':
                var isDomEmpty = document.body === null || document.body.childElementCount === 0;
                _safeSendResponse({result: isDomEmpty});
                break;
            default:
                console.error('Unknown message type: %s', msg.type);
        }
    }

    chrome.runtime.onMessage.addListener(_onTabMessageHandler);
}