﻿/* turbo.net chrome extension content script */

if(typeof(turboNetExtensionInitialized) == "undefined") {
  turboNetExtensionInitialized = true;

  // NOTE: this is executed after page load and is not deterministic with other window.onload handlers.
  // NOTE: this is NOT executed after inline install until after the page is restarted.

  // check if is a page that wants us
  var isTurboServer = false;
  for(var i = 0; i < document.scripts.length; ++i) {
    if(document.scripts[i].src.toLowerCase().includes("/plugin/api")) { // horrible hack to support old turbo server versions. remove this once all old turbo server versions have been upgraded.
      isTurboServer = true;
      break;
    }
  }
  var hostname = window.location.hostname.toLowerCase();
  if(hostname.endsWith(".turbo.net") || hostname == "turbo.net" ||  // always use on turbo.net
      document.getElementById("USETURBOEXTENSION") != null || // add "<div id='USETURBOEXTENSION'/>" to document somewhere to allow use of extension
      isTurboServer) { // use on turbo server. new versions of turbo server should use the USETURBOEXTENSION div method. once everyone is upgraded, should remove this craziness.

    // inject a div for extension check
    var obj = document.createElement("div");
    obj.setAttribute("id", "spoon-plugin-kncgbdglledmjmpnikebkagnchfdehbm-2"); // kept here only for backwards compat with turbo server with old js.
    obj.setAttribute("style", "display:none");
    document.body.appendChild(obj);
    
    obj = document.createElement("div");
    obj.setAttribute("id", "turbo-plugin-ldibmiofagdkgiphkcokpooepankmacl");
    obj.setAttribute("style", "display:none");
    obj.innerHTML = "17.9.1614";
    document.body.appendChild(obj);

    // marshal communications between web page and extension background
    var port = chrome.runtime.connect();

    function _OnPageMessageHandler(event) {
      // We only accept messages from ourselves
      if (event.source != window)
        return;

      if (!event.data.type)
        return;

      if(event.data.type == "TO_SPOON_EXT_2") {
        // changed interface to support filtering messages for the specified extension id
        if (event.data.extensionId && event.data.cmd) {
          if (event.data.extensionId == chrome.runtime.id) {
              
            // set the domain/referrer of the message
            if(event.data.cmd.command == "websocket") {
              var a = event.data.cmd.params.command.split(';');
              if(a.length >= 4 && a[1] == "command") {
                a[2] = document.location.href;
                a[3] = document.referrer;
                event.data.cmd.params.command = a.join(';');
              }
            }

            // post the message
            port.postMessage(event.data.cmd);
          }
        }
        else {
          console.log("Unknown message for turbo.net extension");
        }
      }
    }

    function _OnExtensionMessageHandler(msg) {
      if (!msg.type || msg.type != "FROM_SPOON_EXT")
        return;

      // pass msg on to the page
      window.postMessage(msg, "*");
    }

    window.addEventListener("message", _OnPageMessageHandler, false);
    port.onMessage.addListener(_OnExtensionMessageHandler);
  }
}
